Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 10149)
@@ -38,15 +38,15 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_zdftmx = .TRUE.    !: tidal mixing flag
 
-   !                       !!* Namelist  namzdf_tmx : tidal mixing *
-   REAL(wp) ::  rn_htmx     ! vertical decay scale for turbulence (meters)
-   REAL(wp) ::  rn_n2min    ! threshold of the Brunt-Vaisala frequency (s-1)
-   REAL(wp) ::  rn_tfe      ! tidal dissipation efficiency (St Laurent et al. 2002)
-   REAL(wp) ::  rn_me       ! mixing efficiency (Osborn 1980)
-   LOGICAL  ::  ln_tmx_itf  ! Indonesian Through Flow (ITF): Koch-Larrouy et al. (2007) parameterization
-   REAL(wp) ::  rn_tfe_itf  ! ITF tidal dissipation efficiency (St Laurent et al. 2002)
-
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   en_tmx     ! energy available for tidal mixing (W/m2)
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   mask_itf   ! mask to use over Indonesian area
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   az_tmx     ! coefficient used to evaluate the tidal induced Kz
+   !                              !!* Namelist  namzdf_tmx : tidal mixing *
+   REAL(wp)        ::  rn_htmx     ! vertical decay scale for turbulence (meters)
+   REAL(wp)        ::  rn_n2min    ! threshold of the Brunt-Vaisala frequency (s-1)
+   REAL(wp)        ::  rn_tfe      ! tidal dissipation efficiency (St Laurent et al. 2002)
+   REAL(wp)        ::  rn_me       ! mixing efficiency (Osborn 1980)
+   LOGICAL, PUBLIC ::  ln_tmx_itf  ! Indonesian Through Flow (ITF): Koch-Larrouy et al. (2007) parameterization
+   REAL(wp)        ::  rn_tfe_itf  ! ITF tidal dissipation efficiency (St Laurent et al. 2002)
+
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)         ::   en_tmx     ! energy available for tidal mixing (W/m2)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC ::   mask_itf   ! mask to use over Indonesian area
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)       ::   az_tmx     ! coefficient used to evaluate the tidal induced Kz
 
    !! * Substitutions
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 10149)
@@ -61,4 +61,5 @@
    USE asminc          ! assimilation increments     
    USE asmbkg          ! writing out state trajectory
+   USE asmbgc          ! biogeochemical assimilation increments
    USE diaptr          ! poleward transports           (dia_ptr_init routine)
    USE diadct          ! sections transports           (dia_dct_init routine)
@@ -160,4 +161,5 @@
                 IF( ln_dyninc ) CALL dyn_asm_inc( nit000 - 1 )    ! Dynamics
                 IF( ln_sshinc ) CALL ssh_asm_inc( nit000 - 1 )    ! SSH
+                IF( lk_bgcinc ) CALL bgc_asm_inc( nit000 - 1 )    ! BGC
              ENDIF
           ENDIF
@@ -191,4 +193,6 @@
 
       IF( lk_diaobs   )   CALL dia_obs_wri
+      !
+      IF( ( lk_asminc ).AND.( ln_balwri ) ) CALL asm_bgc_bal_wri( nitend )  ! Output balancing increments
       !
       IF( ln_icebergs )   CALL icb_end( nitend )
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 10149)
@@ -253,4 +253,6 @@
       ! Passive Tracer Model
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      IF( lk_asminc .AND. ln_asmiau .AND. lk_bgcinc ) &
+         &               CALL bgc_asm_inc( kstp )     ! biogeochemistry assimilation
                          CALL trc_stp( kstp )         ! time-stepping
 #endif
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90	(revision 10149)
@@ -74,7 +74,9 @@
                                    jriver_alk, jriver_c,                  &
                                    jriver_n, jriver_si,                   &
+                                   ln_foam_medusa,                        &
                                    riv_alk, riv_c, riv_n, riv_si,         &
                                    zn_dms_chd, zn_dms_chn, zn_dms_din,    &
                                    zn_dms_mld, zn_dms_qsr,                &
+                                   f2_pco2w, f2_fco2w,                    &
                                    xnln, xnld 
       USE trc,               ONLY: med_diag
@@ -87,4 +89,5 @@
 #  else
       USE trcco2_medusa,     ONLY: trc_co2_medusa
+      USE mocsy_mainmod,     ONLY: p2fCO2
 #  endif
       USE trcdms_medusa,     ONLY: trc_dms_medusa
@@ -327,4 +330,8 @@
                      iters, ' AT (', ji, ', ', jj, ', 1) AT ', kt
                endif
+               IF ( ln_foam_medusa ) THEN
+                  !! DAF (Aug 2017): calculate fCO2 for observation operator
+                  CALL p2fCO2( f_pco2w, ztmp, f_pp0, 0.0, 1, f_fco2w )
+               ENDIF
             ENDIF
          ENDDO
@@ -506,4 +513,9 @@
                               CO2flux_conv
                !! ENDIF
+               IF ( ln_foam_medusa ) THEN
+                  !! DAF (Aug 2017): Save pCO2 and fCO2 for observation operator
+                  f2_pco2w(ji,jj) = f_pco2w(ji,jj)
+                  f2_fco2w(ji,jj) = f_pco2w(ji,jj)
+               ENDIF
                IF ( lk_iomput ) THEN
                   IF( med_diag%ATM_PCO2%dgsave ) THEN
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 10149)
@@ -46,4 +46,6 @@
                                    f3_co3, f3_h2co3, f3_hco3,           &
                                    f3_omarg, f3_omcal, f3_pH,           &
+                                   ln_foam_medusa, mld_max, pgrow_avg,  &
+                                   ploss_avg, phyt_avg,                 &
                                    za_sed_c, za_sed_ca, za_sed_fe,      &
                                    za_sed_n, za_sed_si,                 &
@@ -55,4 +57,5 @@
       USE trc,               ONLY: med_diag, nittrc000, trn 
       USE trcnam_trp,        ONLY: ln_trcadv_cen2, ln_trcadv_tvd
+      USE zdfmxl,            ONLY: hmld
  
       !! time (integer timestep)
@@ -113,4 +116,25 @@
 # endif      
 
+      IF ( ln_foam_medusa ) THEN
+         !!----------------------------------------------------------------------
+         !! Diagnostics required for ocean colour assimilation:
+         !! Mixed layer average phytoplankton growth, loss and concentration
+         !! Maximum mixed layer depth
+         !!----------------------------------------------------------------------
+         !!
+         DO jj = 2,jpjm1
+            DO ji = 2,jpim1
+               IF ( hmld(ji,jj) .GT. 0.0 ) THEN
+                  pgrow_avg(ji,jj) = pgrow_avg(ji,jj) / hmld(ji,jj)
+                  ploss_avg(ji,jj) = ploss_avg(ji,jj) / hmld(ji,jj)
+                  phyt_avg(ji,jj)  = phyt_avg(ji,jj)  / hmld(ji,jj)
+                  IF ( hmld(ji,jj) .GT. mld_max(ji,jj) ) THEN
+                     mld_max(ji,jj) = hmld(ji,jj)
+                  ENDIF
+               ENDIF
+            END DO
+         END DO
+      ENDIF
+
 #  if defined key_debug_medusa
          !! AXY (12/07/17)
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90	(revision 10149)
@@ -35,5 +35,5 @@
       USE bio_medusa_mod
       USE par_oce,           ONLY: jpi, jpj, jpk
-      USE sms_medusa,        ONLY: jdms
+      USE sms_medusa,        ONLY: jdms, pgrow_avg, ploss_avg, phyt_avg, mld_max
       USE trc,               ONLY: ln_diatrc, med_diag, nittrc000 
       USE in_out_manager,    ONLY: lwp, numout
@@ -195,4 +195,11 @@
       fslowsinkc(:,:) = 0.0
 # endif      
+      !!
+      pgrow_avg(:,:) = 0.0
+      ploss_avg(:,:) = 0.0
+      phyt_avg(:,:)  = 0.0
+      IF( kt == nittrc000 ) THEN
+         mld_max(:,:) = 0.0
+      ENDIF
       !!
       !! allocate and initiate 2D diag
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/plankton.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/plankton.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/plankton.F90	(revision 10149)
@@ -36,13 +36,22 @@
                                    fdpn, fdpn2, fdzme, fdzme2,             &
                                    fdzmi, fdzmi2, fsdiss, fsin,            &
+                                   fdep1, fprn, fprd,                      &
+                                   fgmepd, fgmepn, fgmipn,                 &
                                    zphd, zphn, zpds, zzme, zzmi
-      USE dom_oce,           ONLY: tmask
+      USE dom_oce,           ONLY: e3t_0, e3t_n, gdepw_0, gdepw_n, tmask
+      USE par_kind,          ONLY: wp
       USE par_oce,           ONLY: jpim1, jpjm1
       USE phytoplankton_mod, ONLY: phytoplankton
       USE sms_medusa,        ONLY: jmpd, jmpn, jmzme, jmzmi,               &
+                                   ln_foam_medusa,                         &
+                                   pgrow_avg, ploss_avg, phyt_avg,         &
                                    xkphd, xkphn, xkzme, xkzmi,             &
                                    xmetapd, xmetapn, xmetazme, xmetazmi,   &
                                    xmpd, xmpn, xmzme, xmzmi, xsdiss
+      USE zdfmxl,            ONLY: hmld
       USE zooplankton_mod,   ONLY: zooplankton
+
+   !!* Substitution
+#  include "domzgr_substitute.h90"
 
       !! Level
@@ -50,4 +59,6 @@
 
       INTEGER :: ji, jj
+
+      REAL(wp) :: fq0
 
       !!-------------------------------------------------------------------
@@ -188,4 +199,39 @@
       ENDDO
 
+      IF ( ln_foam_medusa ) THEN
+         !! Mixed layer averages for ocean colour assimilation
+         !!
+         DO jj = 2,jpjm1
+            DO ji = 2,jpim1
+               IF (tmask(ji,jj,jk) == 1) THEN
+                  if (fdep1(ji,jj).le.hmld(ji,jj)) then
+                     !! this level is entirely in the mixed layer
+                     fq0 = 1.0
+                  elseif (fsdepw(ji,jj,jk).ge.hmld(ji,jj)) then
+                     !! this level is entirely below the mixed layer
+                     fq0 = 0.0
+                  else
+                     !! this level straddles the mixed layer
+                     fq0 = (hmld(ji,jj) - fsdepw(ji,jj,jk)) / fse3t(ji,jj,jk)
+                  endif
+                  !!
+                  pgrow_avg(ji,jj) = pgrow_avg(ji,jj) +                   &
+                                     (((fprn(ji,jj) * zphn(ji,jj)) +      &
+                                       (fprd(ji,jj) * zphd(ji,jj))  ) *   &
+                                      fse3t(ji,jj,jk) * fq0)
+                  ploss_avg(ji,jj) = ploss_avg(ji,jj) +                   &
+                                     ((fgmepd(ji,jj) + fdpd(ji,jj) +      &
+                                       fdpd2(ji,jj)                +      &
+                                       fgmepn(ji,jj) + fdpn(ji,jj) +      &
+                                       fdpn2(ji,jj)  + fgmipn(ji,jj) ) *  &
+                                      fse3t(ji,jj,jk) * fq0)
+                  phyt_avg(ji,jj)  = phyt_avg(ji,jj)  +                   &
+                                     ((zphn(ji,jj) + zphd(ji,jj)) *       &
+                                      fse3t(ji,jj,jk) * fq0)
+               ENDIF
+            ENDDO
+         ENDDO
+      ENDIF
+
    END SUBROUTINE plankton
 
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/sms_medusa.F90	(revision 10149)
@@ -212,4 +212,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: f2_ccd_arg  !: 2D aragonite CCD depth
 !!
+!! 2D fields of pCO2 and fCO2 for observation operator
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: f2_pco2w    !: 2D pCO2
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: f2_fco2w    !: 2D fCO2
+!!
 !! 2D fields of organic and inorganic material sedimented on the seafloor
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: zb_sed_n    !: 2D organic nitrogen   (before)
@@ -289,4 +293,5 @@
    INTEGER  :: co2_rec
    REAL(wp) :: co2_yinit, co2_yend    !: First and Last year read in the xCO2.atm file
+   REAL(wp) :: xobs_xco2a             !: Observed atmospheric xCO2, from namelist
 #endif
 
@@ -349,4 +354,15 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   :: cmask       !: ???
 
+!!----------------------------------------------------------------------
+!! Parameters required for ocean colour assimilation
+!!----------------------------------------------------------------------
+!!
+   LOGICAL :: ln_foam_medusa                                 !: Flag to calculate and save diagnostics
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: pgrow_avg  !: Mixed layer average phytoplankton growth
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: ploss_avg  !: Mixed layer average phytoplankton loss
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: phyt_avg   !: Mixed layer average phytoplankton
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: mld_max    !: Maximum mixed layer depth
+!!
+
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
@@ -361,5 +377,5 @@
       !!----------------------------------------------------------------------
       USE lib_mpp , ONLY: ctl_warn
-      INTEGER ::   ierr(8)        ! Local variables
+      INTEGER ::   ierr(9)        ! Local variables
       !!----------------------------------------------------------------------
       ierr(:) = 0
@@ -371,4 +387,5 @@
       !* 2D and 3D fields of carbonate system parameters
       ALLOCATE( f2_ccd_cal(jpi,jpj)  , f2_ccd_arg(jpi,jpj)  ,       &
+                f2_pco2w(jpi,jpj)    , f2_fco2w(jpi,jpj)    ,       &
          &      f3_pH(jpi,jpj,jpk)   , f3_h2co3(jpi,jpj,jpk),       &
          &      f3_hco3(jpi,jpj,jpk) , f3_co3(jpi,jpj,jpk)  ,       &
@@ -419,4 +436,7 @@
          &      ffln(jpi,jpj,jpk)    , fflf(jpi,jpj,jpk)    ,       &
          &      ffls(jpi,jpj,jpk)    , cmask(jpi,jpj)       ,    STAT=ierr(8) ) 
+      !* Fields for ocean colour data assimilation
+      ALLOCATE( pgrow_avg(jpi,jpj)   , ploss_avg(jpi,jpj)   ,       &
+         &      phyt_avg(jpi,jpj)    , mld_max(jpi,jpj)     ,    STAT=ierr(9) )
 #endif
       !
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 10149)
@@ -105,5 +105,10 @@
       USE sbc_oce,                    ONLY: lk_oasis
       USE sms_medusa,                 ONLY: hist_pco2, co2_yinit, co2_yend, &
-                                            lk_pi_co2
+# if defined key_roam
+                                            xobs_xco2a,                     &
+# endif
+                                            pgrow_avg,                      &
+                                            ploss_avg, phyt_avg, mld_max,   &
+                                            lk_pi_co2, ln_foam_medusa
       USE trc,                        ONLY: ln_rsttr, nittrc000, trn
       USE bio_medusa_init_mod,        ONLY: bio_medusa_init
@@ -330,4 +335,7 @@
          !! f_xco2a(:,:) = 284.725       !! CMIP5 pre-industrial pCO2
          f_xco2a(:,:) = 284.317          !! CMIP6 pre-industrial pCO2 
+      ELSEIF ( xobs_xco2a > 0.0 ) THEN
+         IF(lwp) WRITE(numout,*) ' using observed atm pCO2 = ', xobs_xco2a
+         f_xco2a(:,:) = xobs_xco2a
       ELSE      
          !! xCO2 from file
@@ -418,6 +426,8 @@
       !! now use the NEMO calendar tool : nsec_month to be sure to call 
       !! at the beginning of a new month .
+      !! DAF: For FOAM we want to run daily
       IF ( (kt == nittrc000 .AND. .NOT.ln_rsttr) .OR.                        &
-           ( nsec_month .LE. INT(rdt) ) )  THEN
+           ( nsec_month .LE. INT(rdt) )          .OR.                        &
+           ( nsec_day   .LE. INT(rdt) .AND. ln_foam_medusa ) )  THEN
            IF ( lwp )  WRITE(numout,*)                                       &         
                               ' *** 3D carb chem call *** -- kt:', kt,       &
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 10149)
@@ -330,5 +330,5 @@
       !!----------------------------------------------------------------------
       !! 
-      IF( ( .NOT.lk_oasis ) .AND. ( .NOT.lk_pi_co2 ) ) THEN
+      IF( ( .NOT.lk_oasis ) .AND. ( .NOT.lk_pi_co2 ) .AND. ( xobs_xco2a <= 0.0 ) ) THEN
          IF(lwp) WRITE(numout,*) ' trc_ini_medusa: initialisating atm CO2 record'
          CALL trc_ini_medusa_co2atm
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 10149)
@@ -87,7 +87,9 @@
       &  xsdiss,                                              &
       &  sedlam,sedlostpoc,jpkb,jdms,jdms_input,jdms_model,   &
-      &  scl_chl, chl_out, dmsmin, dmscut, dmsslp
+      &  scl_chl, chl_out, dmsmin, dmscut, dmsslp,            &
+      &  ln_foam_medusa
 #if defined key_roam
       NAMELIST/natroam/ xthetaphy,xthetazoo,xthetanit,        &
+      &    xobs_xco2a,                                        &
       &    xthetarem,xo2min 
 #endif
@@ -255,4 +257,6 @@
       dmscut      = 1.72 !! Anderson DMS default
       dmsslp      = 8.24 !! Anderson DMS default
+!!
+      ln_foam_medusa = .FALSE.
             
       !REWIND(numnatm)
@@ -415,4 +419,7 @@
 !!       chl_out     : select the chl field to send at the UM:
 !!                     1- Surf Chl ; 2- MLD Chl 
+!!
+!! FOAM - observation operator and data assimilation
+!!       ln_foam_medusa : calculate required diagnostics
 
       IF(lwp) THEN
@@ -975,4 +982,8 @@
             ENDIF
          ENDIF ! IF lk_oasis=true
+!! FOAM
+         WRITE(numout,*) '=== FOAM-related parameters'
+         WRITE(numout,*)     &
+         &   ' calculate diagnostics for data assimilation,            ln_foam_medusa = ', ln_foam_medusa
 !!
       ENDIF
@@ -1030,4 +1041,5 @@
       xthetarem = 0.
       xo2min    = 0.
+      xobs_xco2a = 0.
 
       !READ(numnatm,natroam)
@@ -1049,4 +1061,5 @@
 !!       xthetarem :  oxygen consumption by carbon remineralisation
 !!       xo2min    :  oxygen minimum concentration
+!!       xobs_xco2a : observed atmospheric xCO2 (not used if <= 0)
 
       IF(lwp) THEN
@@ -1066,4 +1079,6 @@
           WRITE(numout,*)     &
           &   ' oxygen minimum concentration                               xo2min      = ', xo2min
+          WRITE(numout,*)     &
+          &   ' observed atmospheric xCO2 (not used if <= 0)               xobs_xco2a  = ', xobs_xco2a
        ENDIF
 
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 10149)
@@ -36,5 +36,7 @@
    USE sbc_oce
    USE trcice          ! tracers in sea ice
+# if defined key_medusa
    USE sms_medusa      ! MEDUSA   initialisation
+# endif
    IMPLICIT NONE
    PRIVATE
@@ -107,5 +109,7 @@
       !                                                              ! total volume of the ocean 
       areatot = glob_sum( cvol(:,:,:) )
+# if defined key_medusa && defined key_roam
       carea(:,:) = e1e2t(:,:) * tmask(:,:,1) 
+# endif
 
       IF( lk_pisces  )       CALL trc_ini_pisces       ! PISCES  bio-model
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 10149)
@@ -45,4 +45,5 @@
    USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl, chloro_out_cpl  !! Coupling variable
    USE trcstat
+   USE obs_const, ONLY: obfillflt  ! Observation operator fill value
 
    IMPLICIT NONE
@@ -338,6 +339,34 @@
          IF(lwp) WRITE(numout,*) 'Or don t start from uncomplete restart...' 
       ENDIF
+      !
+      IF ( ln_foam_medusa ) THEN
+         !! 2D fields of pCO2 and fCO2 for observation operator on first timestep
+         IF( iom_varid( numrtr, 'PCO2W', ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) ' MEDUSA pCO2 present - reading in ...'
+            CALL iom_get( numrtr, jpdom_autoglo, 'PCO2W',  f2_pco2w(:,:)  )
+            CALL iom_get( numrtr, jpdom_autoglo, 'FCO2W',  f2_fco2w(:,:)  )
+         ELSE
+            IF(lwp) WRITE(numout,*) ' MEDUSA pCO2 absent - setting to fill ...'
+            f2_pco2w(:,:) = obfillflt * tmask(:,:,1)
+            f2_fco2w(:,:) = obfillflt * tmask(:,:,1)
+         ENDIF
+      ENDIF
 # endif
-
+      IF ( ln_foam_medusa ) THEN
+         !! Fields for ocean colour assimilation on first timestep
+         IF( iom_varid( numrtr, 'pgrow_avg', ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) ' MEDUSA pgrow_avg present - reading in ...'
+            CALL iom_get( numrtr, jpdom_autoglo, 'pgrow_avg',  pgrow_avg(:,:)  )
+            CALL iom_get( numrtr, jpdom_autoglo, 'ploss_avg',  ploss_avg(:,:)  )
+            CALL iom_get( numrtr, jpdom_autoglo, 'phyt_avg',   phyt_avg(:,:)   )
+            CALL iom_get( numrtr, jpdom_autoglo, 'mld_max',    mld_max(:,:)    )
+         ELSE
+            IF(lwp) WRITE(numout,*) ' MEDUSA pgrow_avg absent - setting to zero ...'
+            pgrow_avg(:,:) = 0.0
+            ploss_avg(:,:) = 0.0
+            phyt_avg(:,:)  = 0.0
+            mld_max(:,:)   = 0.0
+         ENDIF
+      ENDIF
 
 #endif
@@ -510,5 +539,19 @@
       call trc_rst_dia_stat( f2_ccd_arg(:,:),'CCD_ARG')
       !!
+      IF ( ln_foam_medusa ) THEN
+         !! Fields for observation operator on first timestep
+         IF(lwp) WRITE(numout,*) ' MEDUSA OBS fields - writing out ...'
+         CALL iom_rstput( kt, nitrst, numrtw, 'PCO2W', f2_pco2w(:,:)  )
+         CALL iom_rstput( kt, nitrst, numrtw, 'FCO2W', f2_fco2w(:,:)  )
+      ENDIF
 # endif
+      IF ( ln_foam_medusa ) THEN
+         !! Fields for assimilation on first timestep
+         IF(lwp) WRITE(numout,*) ' MEDUSA ASM fields - writing out ...'
+         CALL iom_rstput( kt, nitrst, numrtw, 'pgrow_avg', pgrow_avg(:,:) )
+         CALL iom_rstput( kt, nitrst, numrtw, 'ploss_avg', ploss_avg(:,:) )
+         CALL iom_rstput( kt, nitrst, numrtw, 'phyt_avg',  phyt_avg(:,:)  )
+         CALL iom_rstput( kt, nitrst, numrtw, 'mld_max',   mld_max(:,:)   )
+      ENDIF
 !!
 #endif
